{
(C) 3.1998, 8.2000, 1.2007  Petr Lastovicka
}
program tetris;
uses dos,crt,graph;
type kostka=array[1..4,1..4] of byte;
const vyska=27; sirka=14; v=16; xtext=370;
      xstat=640-4*(4*v+9); ystat=480-12*v; okraj=(xstat-sirka*v)div 2;
      pocet=8;
      k:array [1..65] of byte = {vka,ka,barva,bity}
      (2,2,10,1,1,1,1, 3,2,14,1,0,1,1,1,0,
       4,1,9,1,1,1,1, 3,2,12,0,1,0,1,1,1, 3,2,13,1,0,1,0,1,1,
       3,2,13,1,0,1,1,0,1, 3,2,11,0,1,1,1,1,0, 3,1,1,1,1,1);
var rr,ss, r,s,i,j, n,nn, radku:integer;
    hraPC:boolean;
    c:char;
    par:string;
    h1,h2,m1,m2,s1,s2,t1,t2, barva, rychlost:word;
    q,qm,rychlost0, hi,body:longint;
    a: kostka;
    stat:array[1..pocet] of word; {statistika}
    pole:array[1..vyska,1..sirka] of byte; {hrac plocha}

{tisk sla v grafickm reimu}
procedure num(x,y,size,number:longint);
var s:string;
begin
 str(number,s);
 settextstyle(0,0,size); setfillstyle(0,0);
 bar(x,y,x+8*size*length(s),y+8*size);
 outtextxy(x,y,s);
end;

procedure tiskcisel;
begin
 setcolor(15);
 num(xtext+90,30,2,body);
 num(xtext+110,60,2,radku);
 num(xtext+155,90,2,rychlost);
end;

{zobraz jednu kostiku}
procedure kub(r,s,color:byte);
var x,y:integer;
begin
 x:=s*v+okraj; y:=r*v;
 if color=0 then begin setfillstyle(0,0); bar(x,y,x+v-1,y+v-1); exit end;
 setfillstyle(1,color-8);
 bar(x,y,x+v-1,y+v-1);
 setfillstyle(1,color); setcolor(color);
 bar(x+4,y+4,x+v-5,y+v-5);
 line(x,y,x+v-1,y+v-1);
 line(x,y+v-1,x+v-1,y)
end;

{naten kostky slo n do pole a , rr,ss,barva}
procedure get(n:integer);
var o,i,r,s:integer;
begin
  i:=1;
  for o:=1 to n do begin
    rr:=k[i]; ss:=k[i+1]; barva:=k[i+2]; i:=i+3;
    for r:=1 to 4 do for s:=1 to 4 do a[r,s]:=0;
    for r:=1 to rr do for s:=1 to ss do begin a[r,s]:=k[i]; i:=i+1 end
  end;
end;

{vrac true, kdy se kostka s n؟m pekrv, jinak ji vytiskne}
function tisk:boolean;
var i,j:integer;
begin
 tisk:=true;
 if (r+rr>vyska)or(s+ss>sirka)or(s<0) then exit;
 for i:=1 to rr do for j:=1 to ss do
   if (pole[i+r,j+s]>0) and (a[i,j]<>0) then exit;
 tisk:=false;
 for i:=1 to rr do for j:=1 to ss do
  if a[i,j]<>0 then begin
    pole[i+r,j+s]:=barva;
    kub(i+r,j+s,barva)
  end;
end;

{smae kostku}
procedure smaz;
var i,j:integer;
begin
 for i:=1 to rr do for j:=1 to ss do
  if a[i,j]<>0 then begin
  pole[i+r,j+s]:=0; kub(i+r,j+s,0)
 end
end;

{tisk pro statistiku a dal kostku; pedchoz je tm pekryta}
procedure tiskkostky(x,y:word);
var r,s:integer;
begin
 for r:=1 to 4 do for s:=1 to 4 do
   kub(r+y div v, s+(x-okraj) div v, a[r,s]*barva);
end;

procedure rotuj(o:boolean); {o je smr rotace}
var az: kostka;
begin
{uprav polohu, aby se bhem rotace kostka neposouvala}
 r:=r+trunc(rr/2)-trunc(ss/2);
 s:=s+trunc(ss/2)-trunc(rr/2);
 if s+rr>sirka then s:=sirka-rr;
 if s<0 then s:=0;
{rotuj pole a}
 for i:=1 to rr do for j:=1 to ss do az[i,j]:=a[i,j];
 i:=rr; rr:=ss; ss:=i;
 for i:=1 to rr do for j:=1 to ss do
  if o then a[i,j]:=az[j,rr+1-i] else a[i,j]:=az[ss+1-j,i]
end;

procedure vlevo;
begin
 smaz; s:=s-1;
 if tisk then begin s:=s+1; tisk end
end;

procedure vpravo;
begin
 smaz; s:=s+1;
 if tisk then begin s:=s-1; tisk end
end;

procedure rotace;
var rz,sz:integer;
begin
 smaz; rz:=r; sz:=s;
 rotuj(false);
 if tisk then begin rotuj(true); r:=rz; s:=sz; tisk end
end;

{rizeni pocitacem}
procedure pocitac;
var i,j,o,hloubka,hloubkam,diry,dirym,d0,d,om,sm:integer;
    zkostka:array[1..4]of integer;
    zpole:array[1..sirka] of integer;
begin
{najdi horn okraj zaplnn sti pole}
 for i:=1 to sirka do begin
   zpole[i]:=vyska+1;
   for j:=1 to vyska do
     if pole[j,i]<>0 then begin zpole[i]:=j; break end;
 end;
 hloubkam:=0; dirym:=100;
{vyzkouej vechna natoen}
 for o:=0 to 3 do begin
  for j:=1 to ss do begin
   zkostka[j]:=0;
   for i:=rr downto 1 do
     if a[i,j]<>0 then begin zkostka[j]:=i; break end;
  end;
 {vyzkouej vechny pozice zleva doprava}
  for i:=0 to sirka-ss do begin
   d0:=zpole[i+1]-zkostka[1];
   diry:=0;
   hloubka:=0;
   for j:=2 to ss do begin
     if zkostka[j]>hloubka then hloubka:=zkostka[j];
     d:=zpole[i+j]-zkostka[j]-d0;
     if d>0 then inc(diry,d)
     else if d<0 then begin inc(d0,d); dec(diry,(j-1)*d) end;
   end;
   inc(hloubka,d0);
  {vyber umstn, kter nejlpe pasuje a je nejne}
   if (diry<dirym)or(diry=dirym)and(hloubka>hloubkam)or(hloubka-hloubkam>5)
   then begin
     dirym:=diry; hloubkam:=hloubka; sm:=i; om:=o;
   end;
  end;
  rotuj(false);
 end;
{nastav pozici kostky}
 for o:=1 to om do rotuj(false);
 s:=sm;
end;

procedure hra;
var y,q:longint;
    p,dolu:boolean;
    i,j:integer;
begin
{inic.pole}
 for r:=1 to pocet do stat[r]:=0;
 for r:=1 to vyska do for s:=1 to sirka do pole[r,s]:=0;
 body:=0; radku:=0; nn:=trunc(random(pocet))+1;
{tisk statistiky}
 cleardevice;
 for s:=1 to pocet do begin
   get(s);
   tiskkostky(xstat+((s-1) mod 4)*(4*v+9), ystat+((s-1) div 4)*6*v)
 end;
{tisk obdlnku a textu}
 setcolor(7); moveto(okraj-1+v,v); linerel(0,vyska*v+1);
 linerel(sirka*v+1,0); linerel(0,-vyska*v-1);
 settextstyle(0,0,1);
 outtextxy(20,460,'ESC = konec,  ENTER = clovek/pocitac,  +,-,0-9 = Rychlost');
 settextstyle(0,0,2);
 outtextxy(xtext,30,'Body:');
 outtextxy(xtext,60,'Radky:');
 outtextxy(xtext,90,'Rychlost:');
 outtextxy(xtext,180,'Dalsi:');
 if hi>0 then begin
   outtextxy(xtext,120,'Hiscore:');
   setcolor(15);
   num(xtext+140,120,2,hi);
 end;
 tiskcisel;
{vytvoen nov kostky}
 repeat
  n:=nn;
 {tisk Dal}
  nn:=trunc(random(pocet))+1;
  get(nn);
  tiskkostky(505,165);
  get(n);
 {tisk statistiky}
  stat[n]:=stat[n]+1;
  settextstyle(0,0,1); setcolor(7);
  num(xstat+v+((n-1) mod 4)*(4*v+9), ystat+((n-1) div 4)*6*v, 1, stat[n]);
  r:=0; s:=(sirka-ss) div 2;
  if hraPC then pocitac;
  if tisk then exit; {konec hry}
  dolu:=false;
 {padn kostky}
  repeat
   q:=rychlost0*(10-rychlost);
   if dolu then q:=q div 10;
   if hraPC then q:=q div 6;
   for y:=0 to q do begin
     if keypressed then begin c:=readkey;
      if c=#27 then begin closegraph; halt end;
      if (c=' ')or(c=#13) then hraPC:=not hraPC;
      if (c>='0')and(c<='9') then begin rychlost:=ord(c)-48; tiskcisel end;
      if (c='+')and(rychlost<9) then begin inc(rychlost); tiskcisel end;
      if (c='-')and(rychlost>0) then begin dec(rychlost); tiskcisel end;
      if c=#0 then
      {kurzorov klvesy}
       case ord(readkey) of
        75: if not hraPC then vlevo;
        77: if not hraPC then vpravo;
        72: if not hraPC then rotace;
        80: begin dolu:=not dolu; break end
       end
     end;
   end;
  {posun o 1 dol}
   if dolu and not hraPC then begin body:=body+1; tiskcisel end;
   smaz; r:=r+1;
  until tisk;
 {dopadnut}
  r:=r-1; tisk;
  body:=body+10; tiskcisel;
 {odbourn plnch dk}
  for r:=r+1 to r+rr do begin
    p:=true;
    for s:=1 to sirka do if pole[r,s]=0 then p:=false;
    if p then begin
    {zvraznn dku}
      gettime(h1,m1,s1,t1);
      repeat
       for j:=1 to sirka do begin
         kub(r,j,23-pole[r,j]);
         for i:=1 to 1000 do;
       end;
       gettime(h2,m2,s2,t2);
      until ((((h2-h1)*60+m2-m1)*60+s2-s1)*100+t2-t1) > 10*(10-rychlost);
     {posu ve nad r o 1 dol}
      for i:= r downto 2 do for j:= 1 to sirka do begin
        pole[i,j]:=pole[i-1,j]; kub(i,j,pole[i,j]) end;
      radku:=radku+1; body:=body+100; tiskcisel;
    end
  end
 until false;
end;

procedure vga;external;{$L egavga.obj}

begin
 registerbgidriver(@vga);
 detectgraph(i,j);initgraph(i,j,'');
{zjisti piblin rychlost procesoru}
 qm:=1024;
 repeat
  qm:=qm*4;
  gettime(h1,m1,s1,t1);
  for q:=1 to qm do for i:=1 to 30 do ;
  gettime(h2,m2,s2,t2);
  rychlost0:=((((h2-h1)*60+m2-m1)*60+s2-s1)*100+t2-t1);
 until (rychlost0>40) or (qm>1000000000);
 if rychlost0=0 then rychlost0:=1;
 rychlost0:=qm div rychlost0;
 randomize;
{peti parametry}
 hraPC:=false; rychlost:=5;
 for i:=1 to ParamCount do begin
   par:=ParamStr(i); c:=par[1];
   if (length(par)=1)and(c>='0')and(c<='9') then rychlost:=ord(c)-48
   else if (c='-')or(c='/') then hraPC:=true;
 end;
 repeat
  hra;
  if body>hi then hi:=body;
  c:=readkey; if c=#0 then c:=readkey;
 until (c='n')or(c='N')or(c=#27)or(c=#45)or(c=#17);
 closegraph
end.